/*
Dataddo Headless BETA API

Dataddo Headless BETA API

API version: 1.0.0-beta.1
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package customer_api

import (
	"encoding/json"
)

// checks if the GoogleAnalytics4ConnectorForm type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &GoogleAnalytics4ConnectorForm{}

// GoogleAnalytics4ConnectorForm struct for GoogleAnalytics4ConnectorForm
type GoogleAnalytics4ConnectorForm struct {
	ConnectorId string `json:"connectorId"`
	TemplateId  string `json:"templateId"`
	Strategy    string `json:"strategy"`
	// Enforcing data types
	EnsureDataTypes map[string]interface{} `json:"ensureDataTypes,omitempty"`
	// Authorizer ID
	OAuthId *string `json:"oAuthId,omitempty"`
	// Label of the source
	Label *string `json:"label,omitempty"`
	// Google Analytics 4 Account ID.
	AccountId *string `json:"accountId,omitempty"`
	// Google Analytics 4 Property ID.
	PropertyId *string `json:"propertyId,omitempty"`
	// Google Analytics 4 Property ID.
	PropertyIds []interface{} `json:"propertyIds,omitempty"`
	// Data range expression
	DateRange *string `json:"dateRange,omitempty"`
	// Metric
	Metric []string `json:"metric,omitempty"`
	// Dimensions
	Dimension []string `json:"dimension,omitempty"`
	// Limit
	Limit *int32 `json:"limit,omitempty"`
}

// NewGoogleAnalytics4ConnectorForm instantiates a new GoogleAnalytics4ConnectorForm object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewGoogleAnalytics4ConnectorForm(connectorId string, templateId string, strategy string) *GoogleAnalytics4ConnectorForm {
	this := GoogleAnalytics4ConnectorForm{}
	this.ConnectorId = connectorId
	this.TemplateId = templateId
	this.Strategy = strategy
	var limit int32 = 10000
	this.Limit = &limit
	return &this
}

// NewGoogleAnalytics4ConnectorFormWithDefaults instantiates a new GoogleAnalytics4ConnectorForm object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewGoogleAnalytics4ConnectorFormWithDefaults() *GoogleAnalytics4ConnectorForm {
	this := GoogleAnalytics4ConnectorForm{}
	var limit int32 = 10000
	this.Limit = &limit
	return &this
}

// GetConnectorId returns the ConnectorId field value
func (o *GoogleAnalytics4ConnectorForm) GetConnectorId() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.ConnectorId
}

// GetConnectorIdOk returns a tuple with the ConnectorId field value
// and a boolean to check if the value has been set.
func (o *GoogleAnalytics4ConnectorForm) GetConnectorIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.ConnectorId, true
}

// SetConnectorId sets field value
func (o *GoogleAnalytics4ConnectorForm) SetConnectorId(v string) {
	o.ConnectorId = v
}

// GetTemplateId returns the TemplateId field value
func (o *GoogleAnalytics4ConnectorForm) GetTemplateId() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.TemplateId
}

// GetTemplateIdOk returns a tuple with the TemplateId field value
// and a boolean to check if the value has been set.
func (o *GoogleAnalytics4ConnectorForm) GetTemplateIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.TemplateId, true
}

// SetTemplateId sets field value
func (o *GoogleAnalytics4ConnectorForm) SetTemplateId(v string) {
	o.TemplateId = v
}

// GetStrategy returns the Strategy field value
func (o *GoogleAnalytics4ConnectorForm) GetStrategy() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.Strategy
}

// GetStrategyOk returns a tuple with the Strategy field value
// and a boolean to check if the value has been set.
func (o *GoogleAnalytics4ConnectorForm) GetStrategyOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Strategy, true
}

// SetStrategy sets field value
func (o *GoogleAnalytics4ConnectorForm) SetStrategy(v string) {
	o.Strategy = v
}

// GetEnsureDataTypes returns the EnsureDataTypes field value if set, zero value otherwise.
func (o *GoogleAnalytics4ConnectorForm) GetEnsureDataTypes() map[string]interface{} {
	if o == nil || IsNil(o.EnsureDataTypes) {
		var ret map[string]interface{}
		return ret
	}
	return o.EnsureDataTypes
}

// GetEnsureDataTypesOk returns a tuple with the EnsureDataTypes field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *GoogleAnalytics4ConnectorForm) GetEnsureDataTypesOk() (map[string]interface{}, bool) {
	if o == nil || IsNil(o.EnsureDataTypes) {
		return map[string]interface{}{}, false
	}
	return o.EnsureDataTypes, true
}

// HasEnsureDataTypes returns a boolean if a field has been set.
func (o *GoogleAnalytics4ConnectorForm) HasEnsureDataTypes() bool {
	if o != nil && !IsNil(o.EnsureDataTypes) {
		return true
	}

	return false
}

// SetEnsureDataTypes gets a reference to the given map[string]interface{} and assigns it to the EnsureDataTypes field.
func (o *GoogleAnalytics4ConnectorForm) SetEnsureDataTypes(v map[string]interface{}) {
	o.EnsureDataTypes = v
}

// GetOAuthId returns the OAuthId field value if set, zero value otherwise.
func (o *GoogleAnalytics4ConnectorForm) GetOAuthId() string {
	if o == nil || IsNil(o.OAuthId) {
		var ret string
		return ret
	}
	return *o.OAuthId
}

// GetOAuthIdOk returns a tuple with the OAuthId field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *GoogleAnalytics4ConnectorForm) GetOAuthIdOk() (*string, bool) {
	if o == nil || IsNil(o.OAuthId) {
		return nil, false
	}
	return o.OAuthId, true
}

// HasOAuthId returns a boolean if a field has been set.
func (o *GoogleAnalytics4ConnectorForm) HasOAuthId() bool {
	if o != nil && !IsNil(o.OAuthId) {
		return true
	}

	return false
}

// SetOAuthId gets a reference to the given string and assigns it to the OAuthId field.
func (o *GoogleAnalytics4ConnectorForm) SetOAuthId(v string) {
	o.OAuthId = &v
}

// GetLabel returns the Label field value if set, zero value otherwise.
func (o *GoogleAnalytics4ConnectorForm) GetLabel() string {
	if o == nil || IsNil(o.Label) {
		var ret string
		return ret
	}
	return *o.Label
}

// GetLabelOk returns a tuple with the Label field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *GoogleAnalytics4ConnectorForm) GetLabelOk() (*string, bool) {
	if o == nil || IsNil(o.Label) {
		return nil, false
	}
	return o.Label, true
}

// HasLabel returns a boolean if a field has been set.
func (o *GoogleAnalytics4ConnectorForm) HasLabel() bool {
	if o != nil && !IsNil(o.Label) {
		return true
	}

	return false
}

// SetLabel gets a reference to the given string and assigns it to the Label field.
func (o *GoogleAnalytics4ConnectorForm) SetLabel(v string) {
	o.Label = &v
}

// GetAccountId returns the AccountId field value if set, zero value otherwise.
func (o *GoogleAnalytics4ConnectorForm) GetAccountId() string {
	if o == nil || IsNil(o.AccountId) {
		var ret string
		return ret
	}
	return *o.AccountId
}

// GetAccountIdOk returns a tuple with the AccountId field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *GoogleAnalytics4ConnectorForm) GetAccountIdOk() (*string, bool) {
	if o == nil || IsNil(o.AccountId) {
		return nil, false
	}
	return o.AccountId, true
}

// HasAccountId returns a boolean if a field has been set.
func (o *GoogleAnalytics4ConnectorForm) HasAccountId() bool {
	if o != nil && !IsNil(o.AccountId) {
		return true
	}

	return false
}

// SetAccountId gets a reference to the given string and assigns it to the AccountId field.
func (o *GoogleAnalytics4ConnectorForm) SetAccountId(v string) {
	o.AccountId = &v
}

// GetPropertyId returns the PropertyId field value if set, zero value otherwise.
func (o *GoogleAnalytics4ConnectorForm) GetPropertyId() string {
	if o == nil || IsNil(o.PropertyId) {
		var ret string
		return ret
	}
	return *o.PropertyId
}

// GetPropertyIdOk returns a tuple with the PropertyId field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *GoogleAnalytics4ConnectorForm) GetPropertyIdOk() (*string, bool) {
	if o == nil || IsNil(o.PropertyId) {
		return nil, false
	}
	return o.PropertyId, true
}

// HasPropertyId returns a boolean if a field has been set.
func (o *GoogleAnalytics4ConnectorForm) HasPropertyId() bool {
	if o != nil && !IsNil(o.PropertyId) {
		return true
	}

	return false
}

// SetPropertyId gets a reference to the given string and assigns it to the PropertyId field.
func (o *GoogleAnalytics4ConnectorForm) SetPropertyId(v string) {
	o.PropertyId = &v
}

// GetPropertyIds returns the PropertyIds field value if set, zero value otherwise.
func (o *GoogleAnalytics4ConnectorForm) GetPropertyIds() []interface{} {
	if o == nil || IsNil(o.PropertyIds) {
		var ret []interface{}
		return ret
	}
	return o.PropertyIds
}

// GetPropertyIdsOk returns a tuple with the PropertyIds field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *GoogleAnalytics4ConnectorForm) GetPropertyIdsOk() ([]interface{}, bool) {
	if o == nil || IsNil(o.PropertyIds) {
		return nil, false
	}
	return o.PropertyIds, true
}

// HasPropertyIds returns a boolean if a field has been set.
func (o *GoogleAnalytics4ConnectorForm) HasPropertyIds() bool {
	if o != nil && !IsNil(o.PropertyIds) {
		return true
	}

	return false
}

// SetPropertyIds gets a reference to the given []interface{} and assigns it to the PropertyIds field.
func (o *GoogleAnalytics4ConnectorForm) SetPropertyIds(v []interface{}) {
	o.PropertyIds = v
}

// GetDateRange returns the DateRange field value if set, zero value otherwise.
func (o *GoogleAnalytics4ConnectorForm) GetDateRange() string {
	if o == nil || IsNil(o.DateRange) {
		var ret string
		return ret
	}
	return *o.DateRange
}

// GetDateRangeOk returns a tuple with the DateRange field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *GoogleAnalytics4ConnectorForm) GetDateRangeOk() (*string, bool) {
	if o == nil || IsNil(o.DateRange) {
		return nil, false
	}
	return o.DateRange, true
}

// HasDateRange returns a boolean if a field has been set.
func (o *GoogleAnalytics4ConnectorForm) HasDateRange() bool {
	if o != nil && !IsNil(o.DateRange) {
		return true
	}

	return false
}

// SetDateRange gets a reference to the given string and assigns it to the DateRange field.
func (o *GoogleAnalytics4ConnectorForm) SetDateRange(v string) {
	o.DateRange = &v
}

// GetMetric returns the Metric field value if set, zero value otherwise.
func (o *GoogleAnalytics4ConnectorForm) GetMetric() []string {
	if o == nil || IsNil(o.Metric) {
		var ret []string
		return ret
	}
	return o.Metric
}

// GetMetricOk returns a tuple with the Metric field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *GoogleAnalytics4ConnectorForm) GetMetricOk() ([]string, bool) {
	if o == nil || IsNil(o.Metric) {
		return nil, false
	}
	return o.Metric, true
}

// HasMetric returns a boolean if a field has been set.
func (o *GoogleAnalytics4ConnectorForm) HasMetric() bool {
	if o != nil && !IsNil(o.Metric) {
		return true
	}

	return false
}

// SetMetric gets a reference to the given []string and assigns it to the Metric field.
func (o *GoogleAnalytics4ConnectorForm) SetMetric(v []string) {
	o.Metric = v
}

// GetDimension returns the Dimension field value if set, zero value otherwise.
func (o *GoogleAnalytics4ConnectorForm) GetDimension() []string {
	if o == nil || IsNil(o.Dimension) {
		var ret []string
		return ret
	}
	return o.Dimension
}

// GetDimensionOk returns a tuple with the Dimension field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *GoogleAnalytics4ConnectorForm) GetDimensionOk() ([]string, bool) {
	if o == nil || IsNil(o.Dimension) {
		return nil, false
	}
	return o.Dimension, true
}

// HasDimension returns a boolean if a field has been set.
func (o *GoogleAnalytics4ConnectorForm) HasDimension() bool {
	if o != nil && !IsNil(o.Dimension) {
		return true
	}

	return false
}

// SetDimension gets a reference to the given []string and assigns it to the Dimension field.
func (o *GoogleAnalytics4ConnectorForm) SetDimension(v []string) {
	o.Dimension = v
}

// GetLimit returns the Limit field value if set, zero value otherwise.
func (o *GoogleAnalytics4ConnectorForm) GetLimit() int32 {
	if o == nil || IsNil(o.Limit) {
		var ret int32
		return ret
	}
	return *o.Limit
}

// GetLimitOk returns a tuple with the Limit field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *GoogleAnalytics4ConnectorForm) GetLimitOk() (*int32, bool) {
	if o == nil || IsNil(o.Limit) {
		return nil, false
	}
	return o.Limit, true
}

// HasLimit returns a boolean if a field has been set.
func (o *GoogleAnalytics4ConnectorForm) HasLimit() bool {
	if o != nil && !IsNil(o.Limit) {
		return true
	}

	return false
}

// SetLimit gets a reference to the given int32 and assigns it to the Limit field.
func (o *GoogleAnalytics4ConnectorForm) SetLimit(v int32) {
	o.Limit = &v
}

func (o GoogleAnalytics4ConnectorForm) MarshalJSON() ([]byte, error) {
	toSerialize, err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o GoogleAnalytics4ConnectorForm) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	toSerialize["connectorId"] = o.ConnectorId
	toSerialize["templateId"] = o.TemplateId
	toSerialize["strategy"] = o.Strategy
	if !IsNil(o.EnsureDataTypes) {
		toSerialize["ensureDataTypes"] = o.EnsureDataTypes
	}
	if !IsNil(o.OAuthId) {
		toSerialize["oAuthId"] = o.OAuthId
	}
	if !IsNil(o.Label) {
		toSerialize["label"] = o.Label
	}
	if !IsNil(o.AccountId) {
		toSerialize["accountId"] = o.AccountId
	}
	if !IsNil(o.PropertyId) {
		toSerialize["propertyId"] = o.PropertyId
	}
	if !IsNil(o.PropertyIds) {
		toSerialize["propertyIds"] = o.PropertyIds
	}
	if !IsNil(o.DateRange) {
		toSerialize["dateRange"] = o.DateRange
	}
	if !IsNil(o.Metric) {
		toSerialize["metric"] = o.Metric
	}
	if !IsNil(o.Dimension) {
		toSerialize["dimension"] = o.Dimension
	}
	if !IsNil(o.Limit) {
		toSerialize["limit"] = o.Limit
	}
	return toSerialize, nil
}

type NullableGoogleAnalytics4ConnectorForm struct {
	value *GoogleAnalytics4ConnectorForm
	isSet bool
}

func (v NullableGoogleAnalytics4ConnectorForm) Get() *GoogleAnalytics4ConnectorForm {
	return v.value
}

func (v *NullableGoogleAnalytics4ConnectorForm) Set(val *GoogleAnalytics4ConnectorForm) {
	v.value = val
	v.isSet = true
}

func (v NullableGoogleAnalytics4ConnectorForm) IsSet() bool {
	return v.isSet
}

func (v *NullableGoogleAnalytics4ConnectorForm) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableGoogleAnalytics4ConnectorForm(val *GoogleAnalytics4ConnectorForm) *NullableGoogleAnalytics4ConnectorForm {
	return &NullableGoogleAnalytics4ConnectorForm{value: val, isSet: true}
}

func (v NullableGoogleAnalytics4ConnectorForm) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableGoogleAnalytics4ConnectorForm) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}
